
// ============
// View Journal
// ============

$(document).ready(function () {

    var $application = $("#APPLICATION_MNEMONIC").val(), $sessionStorage = JSON.parse(sessionStorage.getItem($application) || "{}");

    // -----------
    // Find Button
    // -----------

    $(".btnFind").on("click", function () {

        $sessionStorage.action = "Journal.viewJournal";
        $sessionStorage.pagination = "first";

        sessionStorage.setItem($application, JSON.stringify($sessionStorage));

        $("#spinner-dialog").modal("show");

        formSubmit($sessionStorage);

    });

    $("#find_journal").on("keyup", function (e) {
        if (e.key === "Enter") {
            $(".btnFind").trigger("click");
        }
    });

    // -----------------
    // Clear Find Button
    // -----------------

    $(".btnClearFind").on("click", function () {

        $("#find_journal").val("").trigger("change");

        $sessionStorage.action = "Journal.viewJournal";
        $sessionStorage.pagination = "first";

        sessionStorage.setItem($application, JSON.stringify($sessionStorage));

        $("#spinner-dialog").modal("show");

        formSubmit($sessionStorage);

    });

    // ------------------
    // Pagination Buttons
    // ------------------

    $(".btnPagination").on("click", function () {

        $sessionStorage.action = "Journal.viewJournal";
        $sessionStorage.pagination = $(this).data("pagination");

        sessionStorage.setItem($application, JSON.stringify($sessionStorage));

        $("#spinner-dialog").modal("show");

        formSubmit($sessionStorage);

        delete $sessionStorage.pagination;

        sessionStorage.setItem($application, JSON.stringify($sessionStorage));

    });

    // -----------
    // Done Button
    // -----------

    $(".btnDone").on("click", function () {

        formSubmit({action: ""});

    });

    // --------------
    // Refresh Button
    // --------------

    $(".btnRefresh").on("click", function () {

        window.location.reload();

    });

    // ---------------------
    // Clear Journal Button.
    // ---------------------

    $(".btnClear").on("click", function () {

        $("#confirm-dialog").removeClass().addClass("modal confirm-clear-journal")
                .find(".modal-title").html("Confirm Clear Journal").end()
                .find(".modal-body").html("Are you sure you wish to Clear the Journal?").end()
                .modal("show");

    });

    $("body").on("click", ".confirm-clear-journal .btnConfirmDialogConfirm", function () {

        $.post("./", {action: "Journal.clearJournal"})

                .done(function () {

                    $sessionStorage.toast = "Journal was Cleared";

                    sessionStorage.setItem($application, JSON.stringify($sessionStorage));

                    window.location.reload();

                });

    });

    // -------------------
    // Save Changed Inputs
    // -------------------

    $(".autosave").on("change", function (e) {

        switch (e.target.type) {

            case "text"       :
                $sessionStorage[e.target.name] = $(this).val();
                break;
            case "radio"      :
                $sessionStorage[e.target.name] = $(this).val();
                break;
            case "checkbox"   :
                $sessionStorage[e.target.name] = $(this).prop("checked");
                break;
            case "select-one" :
                $sessionStorage[e.target.name] = $(this).val();
                break;
            case "hidden"     :
                $sessionStorage[e.target.name] = $(this).val();
                break;

            default           :
                $sessionStorage[e.target.name] = $(this).val();
                break;

        }

        sessionStorage.setItem($application, JSON.stringify($sessionStorage));

    });

    // ----------------
    // Initalize Inputs
    // ----------------

    $.each($sessionStorage, function (name, value) {

        var $input = $(":input").filter("[name='" + name + "']");

        if ($input.length > 0) {

            switch ($input.prop("type")) {

                case "text"       :
                    $input.val(value);
                    break;
                case "radio"      :
                    $input.filter("[value=" + value + "]").prop("checked", true);
                    break;
                case "checkbox"   :
                    $input.prop("checked", value);
                    break;
                case "select-one" :
                    $input.val(value);
                    break;
                case "hidden"     :
                    $input.val(value);
                    break;

                default           :
                    $input.val(value);
                    break;

            }

        }

    });

    // ------------------
    // Save preset Inputs
    // ------------------

    $("input[type=radio]:checked").trigger("change");

    // -----------------
    // Per Page Dropdown
    // -----------------

    $("#journals_per_page").on("change", function () {

        $(".btnFind").trigger("click");

    });

});
